# kubevim-vivnfm-client
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: version not set
- Package version: v0.0.4-alpha.14
- Generator version: 7.11.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import kubevim_vivnfm_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import kubevim_vivnfm_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import kubevim_vivnfm_client
from kubevim_vivnfm_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = kubevim_vivnfm_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with kubevim_vivnfm_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = kubevim_vivnfm_client.ViVnfmApi(api_client)
    body = kubevim_vivnfm_client.PbAllocateComputeRequest() # PbAllocateComputeRequest | 

    try:
        # This operation allows requesting the allocation of virtualised compute resources as indicated by the consumer functional block. Result: After successful operation, the VIM has created the internal management objects for the virtualised compute resource and allocated this resource according to the input requirements and constraints. In addition, the VIM shall return to the VNFM information on the newly instantiated virtualised compute resource plus any additional information about the allocate request operation. The VIM may also return intermediate status reports during the allocation process. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
        api_response = api_instance.vi_vnfm_allocate_virtualised_compute_resource(body)
        print("The response of ViVnfmApi->vi_vnfm_allocate_virtualised_compute_resource:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ViVnfmApi->vi_vnfm_allocate_virtualised_compute_resource: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ViVnfmApi* | [**vi_vnfm_allocate_virtualised_compute_resource**](docs/ViVnfmApi.md#vi_vnfm_allocate_virtualised_compute_resource) | **POST** /vivnfm/v5/compute | This operation allows requesting the allocation of virtualised compute resources as indicated by the consumer functional block. Result: After successful operation, the VIM has created the internal management objects for the virtualised compute resource and allocated this resource according to the input requirements and constraints. In addition, the VIM shall return to the VNFM information on the newly instantiated virtualised compute resource plus any additional information about the allocate request operation. The VIM may also return intermediate status reports during the allocation process. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
*ViVnfmApi* | [**vi_vnfm_allocate_virtualised_network_resource**](docs/ViVnfmApi.md#vi_vnfm_allocate_virtualised_network_resource) | **POST** /vivnfm/v5/networks | This operation allows requesting the allocation of virtualised network resources as indicated by the consumer functional block. Result: After successful operation, the VIM has created the internal management objects for the virtualised network resource and allocated this resource. In addition, the VIM shall return to the VNFM information on the newly instantiated virtualised network resource plus any additional information about the allocate request operation. The VIM may also return intermediate status reports during the allocation process. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
*ViVnfmApi* | [**vi_vnfm_create_compute_flavour**](docs/ViVnfmApi.md#vi_vnfm_create_compute_flavour) | **POST** /vivnfm/v5/flavours | This operation allows requesting the creation of a flavour as indicated by the consumer functional block. Result: After successful operation, the VIM has created the Compute Flavour. In addition, the VIM shall return to the VNFM information on the newly created Compute Flavour. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
*ViVnfmApi* | [**vi_vnfm_create_compute_resource_affinity_or_anti_affinity_constraints_group**](docs/ViVnfmApi.md#vi_vnfm_create_compute_resource_affinity_or_anti_affinity_constraints_group) | **POST** /vivnfm/v5/compute/affinity | This operation allows an authorized consumer functional block to request the creation of a resource affinity or anti-affinity constraints group. An anti-affinity group contains resources that are not placed in proximity, e.g. that do not share the same physical NFVI node. An affinity group contains resources that are placed in proximity, e.g. that do share the same physical NFVI node. This operation shall be supported by the VIM. It shall be supported by the VNFM, if the VNFM supports named resource groups for affinity/anti-affinity.
*ViVnfmApi* | [**vi_vnfm_delete_compute_flavour**](docs/ViVnfmApi.md#vi_vnfm_delete_compute_flavour) | **DELETE** /vivnfm/v5/flavours/{computeFlavourId.value} | This operation allows deleting a Compute Flavour. Result: After successful operation, the VIM has deleted the Compute Flavour, so no new Virtualised Compute Resource can be allocated based on it. The already allocated Virtualised Compute Resources are not affected. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
*ViVnfmApi* | [**vi_vnfm_operate_virtualised_compute_resource**](docs/ViVnfmApi.md#vi_vnfm_operate_virtualised_compute_resource) | **POST** /vivnfm/v5/compute/{computeId.value}/{computeOperation} | This operation allows executing specific operation command on instantiated virtualised compute resources. Result: After successful operation, the VIM has executed the requested operation command on the virtualised compute resource. In addition, the VIM shall return to the VNFM information on the new status of the operated virtualised compute resources, operation specific data plus any additional information about the operate request operation. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.
*ViVnfmApi* | [**vi_vnfm_query_compute_flavour**](docs/ViVnfmApi.md#vi_vnfm_query_compute_flavour) | **GET** /vivnfm/v5/flavours | This operation allows querying information about created Compute Flavours. Result: After successful operation, the VIM has queried the internal management objects for the Compute Flavours. The result of the query shall indicate with a standard success/error result if the query has been processed correctly. For a particular query, information about the Compute Flavours that the VNFM has access to and that are matching the filter shall be returned.
*ViVnfmApi* | [**vi_vnfm_query_image**](docs/ViVnfmApi.md#vi_vnfm_query_image) | **GET** /vivnfm/v5/images/{softwareImageId.value} | This operation allows querying the information about a specific software image in the image repository managed by the VIM. Result: As a result of this operation, the producer (VIM) shall indicate to the consumer (VNFM) whether or not it was possible to process the query.
*ViVnfmApi* | [**vi_vnfm_query_image2**](docs/ViVnfmApi.md#vi_vnfm_query_image2) | **POST** /vivnfm/v5/images | This operation allows querying the information about a specific software image in the image repository managed by the VIM. Result: As a result of this operation, the producer (VIM) shall indicate to the consumer (VNFM) whether or not it was possible to process the query.
*ViVnfmApi* | [**vi_vnfm_query_images**](docs/ViVnfmApi.md#vi_vnfm_query_images) | **GET** /vivnfm/v5/images | Software Image Management Interface Requirements: The Software Image Management interface produced by the VIM on the reference point Vi-Vnfm shall support querying information of software image(s) from the VIM. Result: As a result of this operation, the producer (VIM) shall indicate to the consumer (VNFM) whether or not it was possible to process the query
*ViVnfmApi* | [**vi_vnfm_query_virtualised_compute_resource**](docs/ViVnfmApi.md#vi_vnfm_query_virtualised_compute_resource) | **GET** /vivnfm/v5/compute | This operation allows querying information about instantiated virtualised compute resources. Result: After successful operation, the VIM has queried the internal management objects for the virtualised compute resources. The result of the query shall indicate with a standard success/error result if the query has been processed correctly. For a particular query, information about the compute resources that the VNFM has access to and that are matching the filter shall be returned.
*ViVnfmApi* | [**vi_vnfm_query_virtualised_network_resource**](docs/ViVnfmApi.md#vi_vnfm_query_virtualised_network_resource) | **GET** /vivnfm/v5/networks | This operation allows querying information about instantiated virtualised network resources. Result: After successful operation, the VIM has queried the internal management objects for the virtualised network resources. The result of the query shall indicate with a standard success/error result if the query has been processed correctly. For a particular query, information about the network resources that the VNFM has access to and that are matching the filter shall be returned.
*ViVnfmApi* | [**vi_vnfm_terminate_virtualised_compute_resource**](docs/ViVnfmApi.md#vi_vnfm_terminate_virtualised_compute_resource) | **DELETE** /vivnfm/v5/compute/{computeId.value} | This operation allows de-allocating and terminating one or more instantiated virtualised compute resource. When the operation is done on multiple resources, it is assumed to be best-effort, i.e. it can succeed for a subset of the resources, and fail for the remaining ones. Result: After successful operation, the VIM has terminated the virtualised compute resources and removed the internal management objects for those resources. In addition, the VIM shall return to the VNFM information on the terminated virtualised compute resource plus any additional information about the terminate request operation.
*ViVnfmApi* | [**vi_vnfm_terminate_virtualised_network_resource**](docs/ViVnfmApi.md#vi_vnfm_terminate_virtualised_network_resource) | **DELETE** /vivnfm/v5/networks/{networkResourceId.value} | This operation allows de-allocating and terminating one or more an instantiated virtualised network resource(s). When the operation is done on multiple ids, it is assumed to be best-effort, i.e. it can succeed for a subset of the ids, and fail for the remaining ones. Result: After successful operation, the VIM has terminated the virtualised network resources and removed the internal management objects for those resources. In addition, the VIM shall return to the VNFM information on the terminated virtualised network resource plus any additional information about the terminate request operation. If the operation was not successful, the VIM shall return to the VNFM appropriate error information.


## Documentation For Models

 - [AffinityOrAntiAffinityConstraintForCompute](docs/AffinityOrAntiAffinityConstraintForCompute.md)
 - [AffinityOrAntiAffinityConstraintForComputeAffinityOrAntiAffinityResourceList](docs/AffinityOrAntiAffinityConstraintForComputeAffinityOrAntiAffinityResourceList.md)
 - [CertificateData](docs/CertificateData.md)
 - [ComputeRunningState](docs/ComputeRunningState.md)
 - [Filter](docs/Filter.md)
 - [IPAddress](docs/IPAddress.md)
 - [IPAddressPool](docs/IPAddressPool.md)
 - [IPSubnetCIDR](docs/IPSubnetCIDR.md)
 - [IPVersion](docs/IPVersion.md)
 - [Identifier](docs/Identifier.md)
 - [MacAddress](docs/MacAddress.md)
 - [Metadata](docs/Metadata.md)
 - [NetworkQoS](docs/NetworkQoS.md)
 - [NetworkResourceType](docs/NetworkResourceType.md)
 - [NetworkSubnet](docs/NetworkSubnet.md)
 - [NetworkSubnetData](docs/NetworkSubnetData.md)
 - [NetworkType](docs/NetworkType.md)
 - [OperationalState](docs/OperationalState.md)
 - [PbAllocateComputeRequest](docs/PbAllocateComputeRequest.md)
 - [PbAllocateComputeResponse](docs/PbAllocateComputeResponse.md)
 - [PbAllocateNetworkRequest](docs/PbAllocateNetworkRequest.md)
 - [PbAllocateNetworkResponse](docs/PbAllocateNetworkResponse.md)
 - [PbCreateComputeFlavourRequest](docs/PbCreateComputeFlavourRequest.md)
 - [PbCreateComputeFlavourResponse](docs/PbCreateComputeFlavourResponse.md)
 - [PbCreateComputeResourceAffinityOrAntiAffinityConstraintsGroupRequest](docs/PbCreateComputeResourceAffinityOrAntiAffinityConstraintsGroupRequest.md)
 - [PbCreateComputeResourceAffinityOrAntiAffinityConstraintsGroupResponse](docs/PbCreateComputeResourceAffinityOrAntiAffinityConstraintsGroupResponse.md)
 - [PbOperateComputeResponse](docs/PbOperateComputeResponse.md)
 - [PbQueryComputeFlavourResponse](docs/PbQueryComputeFlavourResponse.md)
 - [PbQueryComputeResponse](docs/PbQueryComputeResponse.md)
 - [PbQueryImageRequest](docs/PbQueryImageRequest.md)
 - [PbQueryImageResponse](docs/PbQueryImageResponse.md)
 - [PbQueryImagesResponse](docs/PbQueryImagesResponse.md)
 - [PbQueryNetworkResponse](docs/PbQueryNetworkResponse.md)
 - [PbTerminateComputeResponse](docs/PbTerminateComputeResponse.md)
 - [PbTerminateNetworkResponse](docs/PbTerminateNetworkResponse.md)
 - [ProtobufAny](docs/ProtobufAny.md)
 - [ResourceQuantity](docs/ResourceQuantity.md)
 - [RpcStatus](docs/RpcStatus.md)
 - [ScopeOfAffinityOrAntiAffinityConstraintForCompute](docs/ScopeOfAffinityOrAntiAffinityConstraintForCompute.md)
 - [SoftwareImageInformation](docs/SoftwareImageInformation.md)
 - [TypeOfAffinityOrAntiAffinityConstraint](docs/TypeOfAffinityOrAntiAffinityConstraint.md)
 - [TypeVirtualNic](docs/TypeVirtualNic.md)
 - [UserData](docs/UserData.md)
 - [UserDataUserDataTransportationMethod](docs/UserDataUserDataTransportationMethod.md)
 - [ViVnfmOperateVirtualisedComputeResourceBody](docs/ViVnfmOperateVirtualisedComputeResourceBody.md)
 - [VirtualCompute](docs/VirtualCompute.md)
 - [VirtualComputeFlavour](docs/VirtualComputeFlavour.md)
 - [VirtualCpuData](docs/VirtualCpuData.md)
 - [VirtualCpuDataVirtualCpuPinningData](docs/VirtualCpuDataVirtualCpuPinningData.md)
 - [VirtualCpuPinningDataVirtualCpuPinningPolicy](docs/VirtualCpuPinningDataVirtualCpuPinningPolicy.md)
 - [VirtualCpuPinningDataVirtualCpuPinningRule](docs/VirtualCpuPinningDataVirtualCpuPinningRule.md)
 - [VirtualMemoryData](docs/VirtualMemoryData.md)
 - [VirtualNetwork](docs/VirtualNetwork.md)
 - [VirtualNetworkData](docs/VirtualNetworkData.md)
 - [VirtualNetworkInterface](docs/VirtualNetworkInterface.md)
 - [VirtualNetworkInterfaceData](docs/VirtualNetworkInterfaceData.md)
 - [VirtualNetworkInterfaceIPAM](docs/VirtualNetworkInterfaceIPAM.md)
 - [VirtualStorageData](docs/VirtualStorageData.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




