# coding: utf-8

"""
    vi-vnfm.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from kubevim_vivnfm_client.models.certificate_data import CertificateData
from kubevim_vivnfm_client.models.user_data_user_data_transportation_method import UserDataUserDataTransportationMethod
from typing import Optional, Set
from typing_extensions import Self

class UserData(BaseModel):
    """
    UserData
    """ # noqa: E501
    content: StrictStr = Field(description="Contains the user data to customize a virtualised compute resource at boot-time.")
    method: Optional[UserDataUserDataTransportationMethod] = UserDataUserDataTransportationMethod.CONFIG_DRIVE_PLAINTEXT
    certificate_data: Optional[List[CertificateData]] = Field(default=None, description="Contains the additional user data to store certificate data for the VNF composed of (fully or partially) virtualised compute resource at boot-time. Shall be present if delegation-mode is used. Otherwise it shall be absent.", alias="certificateData")
    __properties: ClassVar[List[str]] = ["content", "method", "certificateData"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in certificate_data (list)
        _items = []
        if self.certificate_data:
            for _item_certificate_data in self.certificate_data:
                if _item_certificate_data:
                    _items.append(_item_certificate_data.to_dict())
            _dict['certificateData'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "content": obj.get("content"),
            "method": obj.get("method") if obj.get("method") is not None else UserDataUserDataTransportationMethod.CONFIG_DRIVE_PLAINTEXT,
            "certificateData": [CertificateData.from_dict(_item) for _item in obj["certificateData"]] if obj.get("certificateData") is not None else None
        })
        return _obj


