# coding: utf-8

"""
    vi-vnfm.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from kubevim_vivnfm_client.models.virtual_cpu_data_virtual_cpu_pinning_data import VirtualCpuDataVirtualCpuPinningData
from typing import Optional, Set
from typing_extensions import Self

class VirtualCpuData(BaseModel):
    """
    Information describing a virtual CPU.
    """ # noqa: E501
    cpu_architecture: Optional[StrictStr] = Field(default=None, description="CPU architecture type. Examples are x86, ARM. The cardinality can be 0 during the allocation request, if no particular CPU architecture type is requested.", alias="cpuArchitecture")
    num_virtual_cpu: StrictInt = Field(description="Number of virtual CPUs.", alias="numVirtualCpu")
    cpu_clock: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Minimum CPU clock rate (e.g. in MHz) available for the virtualised CPU resources. The cardinality can be 0 during the allocation request, if no particular value is requested.", alias="cpuClock")
    virtual_cpu_oversubscription_policy: Optional[StrictStr] = Field(default=None, alias="virtualCpuOversubscriptionPolicy")
    virtual_cpu_pinning: Optional[VirtualCpuDataVirtualCpuPinningData] = Field(default=None, alias="virtualCpuPinning")
    power_state_reqs: Optional[StrictStr] = Field(default=None, description="Virtual CPU power (state) requirements for the virtualised compute resource.", alias="powerStateReqs")
    __properties: ClassVar[List[str]] = ["cpuArchitecture", "numVirtualCpu", "cpuClock", "virtualCpuOversubscriptionPolicy", "virtualCpuPinning", "powerStateReqs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VirtualCpuData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of virtual_cpu_pinning
        if self.virtual_cpu_pinning:
            _dict['virtualCpuPinning'] = self.virtual_cpu_pinning.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VirtualCpuData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cpuArchitecture": obj.get("cpuArchitecture"),
            "numVirtualCpu": obj.get("numVirtualCpu"),
            "cpuClock": obj.get("cpuClock"),
            "virtualCpuOversubscriptionPolicy": obj.get("virtualCpuOversubscriptionPolicy"),
            "virtualCpuPinning": VirtualCpuDataVirtualCpuPinningData.from_dict(obj["virtualCpuPinning"]) if obj.get("virtualCpuPinning") is not None else None,
            "powerStateReqs": obj.get("powerStateReqs")
        })
        return _obj


